version: "3.9"

services:
    frontend:
        build: packages/frontend
        environment:
            NEXT_PUBLIC_ARCELIUS_BE_URL: http://localhost:${ARCELIUS_PORT_BACKEND}
        ports:
            - "${ARCELIUS_PORT_FRONTEND}:3000"
        volumes:
            - ./packages/frontend/locales:/app/locales:ro
            - ./packages/frontend/src:/app/src
            - ./packages/frontend/.babelrc:/app/.babelrc:ro
            - ./packages/frontend/.browserslistrc:/app/.browserslistrc:ro
            - ./packages/frontend/lingui.config.js:/app/lingui.config.js:ro
            - ./packages/frontend/next-env.d.ts:/app/next-env.d.ts
            - ./packages/frontend/next.config.js:/app/next.config.js:ro
            - ./packages/frontend/package-lock.json:/app/package-lock.json:ro
            - ./packages/frontend/package.json:/app/package.json:ro
            - ./packages/frontend/node_modules:/app/node_modules:ro
            - ./packages/frontend/tsconfig.json:/app/tsconfig.json:ro
            - frontend-next_cache:/app/.next
        read_only: false
        depends_on:
            - backend

    backend:
        image: nginx:1.19-alpine
        volumes:
            - ./packages/backend/src:/usr/src/app:ro
            - ./packages/backend/templates:/etc/nginx/templates:ro
            - ./packages/backend/nginx-runtime/cache:/var/cache/nginx
            - ./packages/backend/nginx-runtime/pid:/var/run
            - ./packages/backend/nginx-runtime/logs:/var/log/nginx
            - ./packages/backend/nginx-runtime/config:/etc/nginx/conf.d
        environment:
            - NGINX_PORT=80
        ports:
            - "${ARCELIUS_PORT_BACKEND}:80"
        depends_on:
            - database
            - php
        read_only: true

    database:
        image: jbergstroem/mariadb-alpine:latest
        environment:
            MYSQL_USER: development
            MYSQL_PASSWORD: development
            MYSQL_DATABASE: main
        ports:
            - "${ARCELIUS_PORT_DATABASE}:3306"
        volumes:
            - database:/var/lib/mysql
        read_only: false
        restart: unless-stopped

    php:
        build: ./packages/php
        volumes:
            - ./packages/backend/src:/usr/src/app:ro
        environment:
            ARCELIUS_DB_PORT: 3306
        read_only: true

volumes:
    database:
    frontend-next_cache:
